#include <a8/a8.h>

#include <a8/awaiter.h>

namespace a8
{

    void Awaiter::Await(std::shared_ptr<Awaiter> notifyer)
    {
        notifyers_.push_back(notifyer);
        DoAwait();
    }

    void Awaiter::DoDone()
    {
        done_ = true;
        for (auto notifyer : notifyers_) {
            if (!notifyer.expired()) {
                notifyer.lock()->DoResume();
            }
        }
    }

    void Awaiter::SetResult(std::vector<std::any> results)
    {
        results_ = std::make_shared<a8::Results>(results);
    }

}
