#pragma once

#include <a8/result.h>

namespace f8
{
    class Coroutine;
}

namespace a8
{

    class Awaiter : public std::enable_shared_from_this<Awaiter>
    {
    public:
        virtual ~Awaiter() {};

        std::shared_ptr<a8::Results> GetResult() { return results_; }
        bool Done() const { return done_; }
        virtual void DoResume() {};

    protected:
        bool done_ = false;

        std::list<std::weak_ptr<Awaiter>> notifyers_;
        void Await(std::shared_ptr<Awaiter> notifyer);
        virtual void DoAwait() = 0;
        void DoDone();
        void SetResult(std::vector<std::any> results);

    private:
        std::shared_ptr<a8::Results> results_;
        std::function<void()> cb_;

        friend class f8::Coroutine;
    };

}
