#pragma once

#include <a8/spinlock.h>

namespace a8
{

    class FifoBuffer
    {
    public:

        FifoBuffer(int buf_len);
        ~FifoBuffer();

        char* Alloc(int len);
        void Free(char* p);

    private:

        size_t GetIndex(size_t size);

    private:

        char* buf_ = nullptr;
        int buf_len_ = 0;
        std::atomic<int> offset_ = 0;

        a8::SpinLock lock_;
        std::array<list_head, 10> free_list_;
    };

}
