#include <a8/a8.h>

#include <a8/queue.h>

namespace a8
{

    Queue::Queue()
    {
        INIT_LIST_HEAD(&msg_list_);
        INIT_LIST_HEAD(&work_list_);
    }

    void Queue::Push(list_head* node)
    {
        msg_mutex_.lock();
        list_add_tail(node, &msg_list_);
        msg_mutex_.unlock();
    }

    void Queue::Fetch()
    {
        if (list_empty(&work_list_)) {
            msg_mutex_.lock();
            if (!list_empty(&msg_list_)) {
                list_replace_init(&msg_list_, &work_list_);
            }
            msg_mutex_.unlock();
        }
    }

}
